SELECT t1.PARAM2                                                AS name,
       t1.PARAM1                                                AS userid,
       t1.playduration,
       CONVERT(varchar (100), DATEADD(S, convert(float, t1.createdtime) / 1000, '1970-01-01 08:00'), 120) as datetime,
       t1.province,
       t1.city,
       t1.ipaddress,
       t1.useragent,
       t1.ismobile,
       t1.browser,
       (
           SELECT liveuv
                      AS num
           FROM tlive_sessiondata AS t2
           WHERE t1.sessionid = t2.sessionid
       )                                                        AS viewcount,
       t1.param3                                                AS viewtype
FROM tlive_viewlog AS t1
where t1.sessionid = $sessionid$
  and t1.channelid = $channelid$