select
    t1.tsupplyanddemandid,
    t1.fissupply,
    t1.ftype,
    t1.ftitle,
    t1.fcontent,
    t1.fstatus,
    t1.createby,
    t1.checkby,
    t1.checkdate,
    t1.fenddate,
    t2.fagentname,
    t1.freadtimes,
    t1.tenterprise_userid,
    t1.tagentsid,
    (select count(0) from timdialog where siteid=t1.siteid and ownertable='tsupplyanddemand' and ownerid=t1.tsupplyanddemandid) as fcommunicationtimes
from tsupplyanddemand t1
         inner join tagents t2 on t1.siteid=t2.siteid and t1.tagentsid=t2.tagentsid
         inner join timdialogusers t3 on t3.TENTERPRISE_USERID= $userid$ and t1.TIMDIALOGID_TALKING=t3.timdialogid
         left join (SELECT t5.timdialogid,t5.createdate FROM timdialogmessage as t5
                    WHERE t5.timdialogmessageid in (select MAX(timdialogmessageid)timdialogmessageid from timdialogmessage where siteid=$siteid$ and timdialogid=t5.timdialogid group by timdialogid)) t4 on   t1.TIMDIALOGID_TALKING=t4.timdialogid
where t1.siteid=$siteid$ and t1.fstatus not in ('½') and $where$