package com.cnd3b.restcontroller.customer.supplyanddemand;

import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import com.cnd3b.common.Controller;
import com.cnd3b.common.D3bException;
import com.cnd3b.common.data.Row;
import com.cnd3b.common.data.Rows;
import com.cnd3b.common.data.RowsMap;
import com.cnd3b.common.data.SQLFactory;
import com.cnd3b.common.parameter.parameter;
import p2.pao.PaoRemote;
import p2.pao.PaoSetRemote;
import p2.util.P2Exception;

import java.util.ArrayList;
import java.util.Arrays;

public class supplyanddemand extends Controller {
    public supplyanddemand(JSONObject content) {
        super(content);
    }

    /**
     * бѯ
     *
     * @return
     */
    public String query_supplyanddemandList() {
        String fstatus = "";
        /**
         *
         */
        String[] sortfield = {"case when t1.fstatus in('ѽ','ѹ') then 0 when t1.fstatus='Խ'then 1 else 2 end desc, t1.tsupplyanddemandid desc"};
        String sort = getSort(sortfield, "case when t1.fstatus in('ѽ','ѹ') then 0 when t1.fstatus='Խ'then 1 else 2 end desc, t4.createdate desc,t1.tsupplyanddemandid desc");
        /**
         * 
         */
        StringBuffer where = new StringBuffer(" 1=1 ");
        if (content.containsKey("where")) {
            JSONObject whereObject = content.getJSONObject("where");
            if (whereObject.containsKey("condition") && !"".equals(whereObject.getString("condition"))) {
                where.append(" and(");
                where.append("t1.ftitle like'%").append(whereObject.getString("condition")).append("%' ");
                where.append(")");
            }
            if (whereObject.containsKey("ftype") && !"".equals(whereObject.getString("ftype"))) {
                where.append(" and t1.ftype ='").append(whereObject.getString("ftype")).append("' ");
            }
            if (whereObject.containsKey("fissupply") && !"".equals(whereObject.getString("fissupply"))) {
                where.append(" and t1.fissupply =").append(whereObject.getBooleanValue("fissupply") ? 1 : 0);
            }
            if (whereObject.containsKey("fstatus") && !"".equals(whereObject.getString("fstatus"))) {
                fstatus = whereObject.getString("fstatus");
                if ("Խ".equals(whereObject.getString("fstatus"))) {
                    where.append(" and t1.fstatus ='").append(whereObject.getString("fstatus")).append("' and t1.tenterprise_userid !=" + userid);
                } else {
                    where.append(" and t1.fstatus ='").append(whereObject.getString("fstatus")).append("'");
                }
            }
        }
        SQLFactory sqlFactory;
        if (fstatus.equals("Խ")) {
            sort = "t4.createdate desc,t1.tsupplyanddemandid desc";
            sqlFactory = new SQLFactory(this, "бѯ_Խ", pageSize, pageNumber, sort);
        } else {
            sort = "t1.createdate desc,t1.tsupplyanddemandid desc";
            sqlFactory = new SQLFactory(this, "бѯ", pageSize, pageNumber, sort);
        }


        sqlFactory.addParameter("siteid", siteid);
        sqlFactory.addParameter("userid", userid);
        sqlFactory.addParameter_SQL("where", where);
        String sql = sqlFactory.getSQL();
//        System.err.println(sqlFactory.getSQL());
        Rows rows = dbConnect.runSqlQuery(sqlFactory.getSQL());
        RowsMap attinfoRowsMap = getAttachmentUrl("tsupplyanddemand", rows.toArrayList("tsupplyanddemandid"));


        SQLFactory dialoglistSQL = new SQLFactory(this, "ѯ_Իб");
        dialoglistSQL.addParameter("siteid", siteid);
        dialoglistSQL.addParameter("userid", userid);
        dialoglistSQL.addParameter_in("tsupplyanddemandid", rows.toArrayList("tsupplyanddemandid"));
//        String sql = dialoglistSQL.getSQL();
//        System.err.println(sql);

        Rows dialogrows = dbConnect.runSqlQuery(dialoglistSQL.getSQL());

        SQLFactory timnewmsgSQL = new SQLFactory(this, "ʱͨѶȺϢѯ");
        timnewmsgSQL.addParameter("siteid", siteid);
        timnewmsgSQL.addParameter("userid", userid);
        timnewmsgSQL.addParameter_in("timdialogid", dialogrows.toArrayList("timdialogid"));
//        String sql2 = timnewmsgSQL.getSQL();
//        System.err.println(sql2);
        RowsMap newmsgmap = timnewmsgSQL.runSqlQuery().toRowsMap("timdialogid");
        for (Row drow : dialogrows) {
            Rows newmsgrows = newmsgmap.get(drow.getString("timdialogid"));
            for (Row newmsg : newmsgrows) {
                try {
                    newmsg.put("message", JSONObject.parseObject(newmsg.getString("message")));
                } catch (Exception e) {
                    e.printStackTrace();
                    newmsg.put("message", "{}");
                }
                newmsg.put("fisonline", parameter.websocketClients.containsKey(newmsg.getLong("tenterprise_userid")) ? 1 : 0);
            }
            drow.put("latestnews", newmsgrows);//Ϣ
        }
        RowsMap map = dialogrows.toRowsMap("ownerid");

        for (Row row : rows) {
//            System.err.println("row:"+row.getString("tsupplyanddemandid"));
            row.put("imdialogs", map.get(row.getString("tsupplyanddemandid")));
            //Ϣ
            row.put("attinfos", attinfoRowsMap.get(row.getString("tsupplyanddemandid")));
            //ͷ
            row.put("headportraiturl", getHeadPic(row.getLong("tenterprise_userid")));
        }
        return getSucReturnObject().setDataByPaging(rows).saveToDataPool().toString();
    }

    /**
     * ѯ
     *
     * @return
     */
    public String query_supplyanddemandMain() throws P2Exception {
        long tsupplyanddemandid = content.getLong("tsupplyanddemandid");
        /**
         * Ķ+1
         */
        dbConnect.runSqlUpdate("update tsupplyanddemand set freadtimes=isnull(freadtimes,0)+1 where siteid='" + siteid + "' and tsupplyanddemandid='" + tsupplyanddemandid + "'");

        SQLFactory sqlFactory = new SQLFactory(this, "ѯ");
        sqlFactory.addParameter("siteid", siteid);
        sqlFactory.addParameter("tsupplyanddemandid", tsupplyanddemandid);
        Rows rows = dbConnect.runSqlQuery(sqlFactory.getSQL());

        RowsMap attinfoRowsMap = getAttachmentUrl("tsupplyanddemand", rows.toArrayList("tsupplyanddemandid"));

        for (Row row : rows) {
            row.put("attinfos", attinfoRowsMap.get(row.getString("tsupplyanddemandid")));
            //ͷ
            row.put("headportraiturl", getHeadPic(row.getLong("tenterprise_userid")));
        }
        return getSucReturnObject().setData(rows).toString();
    }

    /**
     * һϵԻ
     *
     * @return
     */
    public String OpenImDialog() throws P2Exception {
        long tsupplyanddemandid = content.getLong("tsupplyanddemandid");

        Rows imdialogRows = dbConnect.runSqlQuery("select timdialogid,tenterprise_userid from timdialog where siteid='" + siteid + "' and ownertable='tsupplyanddemand' and ownerid='" + tsupplyanddemandid + "' and tenterprise_userid=" + userid);
        long timdialogid;
        if (!imdialogRows.isEmpty()) {
            timdialogid = imdialogRows.get(0).getLong("timdialogid");
        } else {
            Rows rows = dbConnect.runSqlQuery("select ftitle,tenterprise_userid from tsupplyanddemand where siteid='" + siteid + "' and tsupplyanddemandid='" + tsupplyanddemandid + "'");
            if (!rows.isEmpty()) {
                if(rows.get(0).getString("fstatus").equals("Խ")){
                    return getErrReturnObject().setErrMsg("ڶԽ").toString();
                }
                //Ի򲻴ʱԶһԻ
                PaoSetRemote timdialogSet = getP2ServerSystemPaoSet("timdialog");
                PaoRemote timdialog = timdialogSet.addAtEnd();
                timdialog.setValue("siteid", siteid, 11L);//ҵID
                timdialog.setValue("createby", username, 11L);//
                timdialog.setValue("createdate", sysdate, 11L);//ʱ
                timdialog.setValue("fimdialogtype", "", 11L);//Ի
                timdialog.setValue("ownertable", "tsupplyanddemand", 11L);//б
                timdialog.setValue("ownerid", tsupplyanddemandid, 11L);//бID
                timdialog.setValue("tenterprise_userid", userid, 11L);//˺ID
                timdialog.setValue("fimdialogname", rows.get(0).getString("ftitle"), 11L);
                timdialogid = timdialog.getUniqueIDValue();
                timdialogSet.save();

                SQLFactory addusers = new SQLFactory(this, "ʱͨѶȺԱ");
                addusers.addParameter("createby", username);
                addusers.addParameter("timdialogid", timdialogid);
                addusers.addParameter("siteid", siteid);
                addusers.addParameter_in("tenterprise_userid", new String[]{String.valueOf(userid), rows.get(0).getString("tenterprise_userid")});
                dbConnect.runSqlUpdate(addusers.getSQL());
            } else {
                return getErrReturnObject().setErrMsg("һϵʧܣ").toString();
            }
        }
        JSONObject object = new JSONObject();
        object.put("timdialogid", timdialogid);

        JSONArray array = new JSONArray();
        array.add(object);
        return getSucReturnObject().setData(array).toString();
    }

    /**
     * ҵĹбѯ
     *
     * @return
     */
    public String query_mysupplyanddemandList() {
        /**
         *
         */
        String[] sortfield = {"case when t1.fstatus in('ѽ','ѹ') then 0 when t1.fstatus='Խ'then 1 else 2 end desc, t1.tsupplyanddemandid desc"};
        String sort = getSort(sortfield, "case when t1.fstatus in('ѽ','ѹ') then 0 when t1.fstatus='Խ'then 1 else 2 end desc, t1.tsupplyanddemandid desc");
        /**
         * 
         */
        StringBuffer where = new StringBuffer(" 1=1 ");
        if (content.containsKey("where")) {
            JSONObject whereObject = content.getJSONObject("where");
            if (whereObject.containsKey("condition") && !"".equals(whereObject.getString("condition"))) {
                where.append(" and(");
                where.append("t1.ftitle like'%").append(whereObject.getString("condition")).append("%' ");
                where.append(")");
            }
            if (whereObject.containsKey("ftype") && !"".equals(whereObject.getString("ftype"))) {
                where.append(" and t1.ftype ='").append(whereObject.getString("ftype")).append("' ");
            }
            if (whereObject.containsKey("fissupply")) {
                where.append(" and t1.fissupply =").append(whereObject.getBooleanValue("fissupply") ? 1 : 0);
            }
        }
        sort= "t1.fstatus,t1.tsupplyanddemandid desc";
        SQLFactory sqlFactory = new SQLFactory(this, "ҵĹбѯ", pageSize, pageNumber, sort);
        sqlFactory.addParameter("siteid", siteid);
        sqlFactory.addParameter("tagentsid", tagentsid);
        sqlFactory.addParameter_SQL("where", where);

        Rows rows = dbConnect.runSqlQuery(sqlFactory.getSQL());
        RowsMap attinfoRowsMap = getAttachmentUrl("tsupplyanddemand", rows.toArrayList("tsupplyanddemandid"));

        for (Row row : rows) {
            row.put("attinfos", attinfoRowsMap.get(row.getString("tsupplyanddemandid")));
            //ͷ
            row.put("headportraiturl", getHeadPic(row.getLong("tenterprise_userid")));
        }
        return getSucReturnObject().setDataByPaging(rows).saveToDataPool().toString();
    }

    /**
     * ҵĹѯ
     *
     * @return
     */
    public String query_mysupplyanddemandMain() {
        long tsupplyanddemandid = content.getLong("tsupplyanddemandid");

        SQLFactory sqlFactory = new SQLFactory(this, "ҵĹѯ");
        sqlFactory.addParameter("siteid", siteid);
        sqlFactory.addParameter("tagentsid", tagentsid);
        sqlFactory.addParameter("tsupplyanddemandid", tsupplyanddemandid);
        Rows rows = dbConnect.runSqlQuery(sqlFactory.getSQL());

        SQLFactory dialoglistSQL = new SQLFactory(this, "ҵĹѯ_Իб");
        dialoglistSQL.addParameter("siteid", siteid);
        dialoglistSQL.addParameter("tagentsid", tagentsid);
        dialoglistSQL.addParameter("tsupplyanddemandid", tsupplyanddemandid);
        dialoglistSQL.addParameter("userid", userid);
        Rows dialogrows = dbConnect.runSqlQuery(dialoglistSQL.getSQL());

        SQLFactory timnewmsgSQL = new SQLFactory(this, "ʱͨѶȺϢѯ");
        timnewmsgSQL.addParameter("siteid", siteid);
        timnewmsgSQL.addParameter("userid", userid);
        timnewmsgSQL.addParameter_in("timdialogid", dialogrows.toArrayList("timdialogid"));
        RowsMap newmsgmap = timnewmsgSQL.runSqlQuery().toRowsMap("timdialogid");
        for (Row row : dialogrows) {
            Rows newmsgrows = newmsgmap.get(row.getString("timdialogid"));
            for (Row newmsg : newmsgrows) {
                newmsg.put("message", JSONObject.parseObject(newmsg.getString("message")));
                newmsg.put("fisonline", parameter.websocketClients.containsKey(newmsg.getLong("tenterprise_userid")) ? 1 : 0);
            }
            row.put("latestnews", newmsgrows);//Ϣ
        }

        RowsMap attinfoRowsMap = getAttachmentUrl("tsupplyanddemand", rows.toArrayList("tsupplyanddemandid"));
        for (Row row : rows) {
            row.put("attinfos", attinfoRowsMap.get(row.getString("tsupplyanddemandid")));
            row.put("imdialogs", dialogrows);
            //ͷ
            row.put("headportraiturl", getHeadPic(row.getLong("tenterprise_userid")));
        }
        return getSucReturnObject().setData(rows).toString();
    }

    /**
     * ޸Ĺ
     *
     * @return
     */
    public String insertormodify() throws D3bException, P2Exception {
        long tsupplyanddemandid = content.getLongValue("tsupplyanddemandid");//IDʱ0
        String ftype = content.getString("ftype");
        String ftitle = content.getString("ftitle", "tsupplyanddemand.ftitle", "");
        String fcontent = content.getString("fcontent", "tsupplyanddemand.fcontent", "");
        String fenddate = content.getString("fenddate");
        boolean fissupply = content.getBoolean("fissupply");

        PaoSetRemote tsupplyanddemandSet = getP2ServerSystemPaoSet("tsupplyanddemand", "siteid='" + siteid + "' and tagentsid='" + tagentsid + "' and tsupplyanddemandid='" + tsupplyanddemandid + "'");
        PaoRemote tsupplyanddemand = null;
        if (tsupplyanddemandid <= 0 || tsupplyanddemandSet.isEmpty()) {
            tsupplyanddemand = tsupplyanddemandSet.addAtEnd();
            tsupplyanddemand.setValue("siteid", siteid, 11L);//ҵID
            tsupplyanddemand.setValue("tagentsid", tagentsid, 11L);//ҵID
            tsupplyanddemand.setValue("createby", username, 11L);//¼
            tsupplyanddemand.setValue("createdate", sysdate, 11L);//¼ʱ
            tsupplyanddemand.setValue("tenterprise_userid", userid, 11L);//˺ID
            tsupplyanddemand.setValue("fissupply", fissupply, 11L);//
            tsupplyanddemand.setValue("fstatus", "½", 11L);//״̬
        } else {
            tsupplyanddemand = tsupplyanddemandSet.getPao(0);
        }
        tsupplyanddemand.setValue("ftype", ftype, 11L);//Ʒ
        tsupplyanddemand.setValue("ftitle", ftitle, 11L);//
        tsupplyanddemand.setValue("fcontent", fcontent, 11L);//
        tsupplyanddemand.setValue("fenddate", fenddate, 11L);//ʱ

        tsupplyanddemand.setValue("changeby", username, 11L);//޸
        tsupplyanddemand.setValue("changedate", sysdate, 11L);//޸ʱ
        content.put("tsupplyanddemandid", tsupplyanddemand.getUniqueIDValue());
        tsupplyanddemandSet.save();
        return query_mysupplyanddemandMain();
    }

    /**
     * ״̬
     *
     * @return
     */
    public String updatesupplyanddemandstatus() {
        long tsupplyanddemandid = content.getLong("tsupplyanddemandid");
        String fstatus = content.getString("fstatus");
        Rows rows = dbConnect.runSqlQuery("select * from tsupplyanddemand where siteid='" + siteid + "' and tsupplyanddemandid='" + tsupplyanddemandid + "'");
        if (rows.isEmpty()) {
            return getErrReturnObject().setErrMsg("ݲ").toString();
        }
        if (!Arrays.asList(new String[]{"½", "", "Խ", "Խ", "ѽ", "ѹ"}).contains(fstatus)) {
            return getErrReturnObject().setErrMsg("ЧĹ״̬").toString();
        }
        long tagentsid = rows.get(0).getLong("tagentsid");
        switch (fstatus) {
            case "½": {
                dbConnect.runSqlUpdate("update tsupplyanddemand set fstatus='½',changeby='" + username + "',changedate=getDate(),checkby=null,checkdate=null where siteid='" + siteid + "' and tagentsid='" + tagentsid + "' and tsupplyanddemandid='" + tsupplyanddemandid + "'");
                break;
            }
            case "": {
                if (!"½".equals(rows.get(0).getString("fstatus"))) {
                    return getErrReturnObject().setErrMsg("ǰ״̬ɷ").toString();
                }
                dbConnect.runSqlUpdate("update tsupplyanddemand set fstatus='Խ',changeby='" + username + "',changedate=getDate(),checkby='" + username + "',checkdate=getDate() where siteid='" + siteid + "' and tagentsid='" + tagentsid + "' and tsupplyanddemandid='" + tsupplyanddemandid + "'");
                break;
            }
            case "ѽ": {
                long timdialogid = content.getLong("timdialogid");
                long tenterprise_userid = content.getLong("tenterprise_userid");
                long tcooperationagentsid = getUser(tenterprise_userid).getLong("tagentsid");
                ArrayList<String> list = new ArrayList<>();
                list.add("update tsupplyanddemand set fstatus='ѽ',changeby='" + username + "',changedate=getDate(),tcooperationagentsid='" + tcooperationagentsid + "',timdialogid_cooperation='" + timdialogid + "' where siteid='" + siteid + "' and tagentsid='" + tagentsid + "' and tsupplyanddemandid='" + tsupplyanddemandid + "'");
                list.add("update timdialog set fdatastatus='1' where siteid='" + siteid + "' and timdialogid='" + timdialogid + "'");
                dbConnect.runSqlUpdate(list);
                break;
            }
            case "Խ": {
                long timdialogid = content.getLong("timdialogid");
                ArrayList<String> list = new ArrayList<>();
                list.add("update tsupplyanddemand set fstatus='Խ',changeby='" + username + "',changedate=getDate(),timdialogid_talking='" + timdialogid + "' where siteid='" + siteid + "' and tagentsid='" + tagentsid + "' and tsupplyanddemandid='" + tsupplyanddemandid + "'");
                list.add("update timdialog set fdatastatus='2' where siteid='" + siteid + "' and timdialogid='" + timdialogid + "'");
                dbConnect.runSqlUpdate(list);
                break;
            }
            case "Խ": {
                long timdialogid = content.getLong("timdialogid");
                ArrayList<String> list = new ArrayList<>();
                list.add("update tsupplyanddemand set fstatus='Խ',changeby='" + username + "',changedate=getDate(),timdialogid_talking=null where siteid='" + siteid + "' and tagentsid='" + tagentsid + "' and tsupplyanddemandid='" + tsupplyanddemandid + "'");
                list.add("update timdialog set fdatastatus='0' where siteid='" + siteid + "' and timdialogid='" + timdialogid + "'");
                dbConnect.runSqlUpdate(list);
                break;
            }
            default: {
                dbConnect.runSqlUpdate("update tsupplyanddemand set fstatus='" + fstatus + "',changeby='" + username + "',changedate=getDate() where siteid='" + siteid + "' and tagentsid='" + tagentsid + "' and tsupplyanddemandid='" + tsupplyanddemandid + "'");
                break;
            }
        }
        return query_mysupplyanddemandMain();
    }

    /**
     * ɾ
     *
     * @return
     */
    public String deletesupplyanddemand() {
        long tsupplyanddemandid = content.getLongValue("tsupplyanddemandid");
        Rows rows = dbConnect.runSqlQuery("select * from tsupplyanddemand where siteid='" + siteid + "' and tagentsid='" + tagentsid + "' and tsupplyanddemandid='" + tsupplyanddemandid + "'");
        if (!rows.isEmpty() && !"½".equals(rows.get(0).getString("fstatus"))) {
            return getErrReturnObject().setErrMsg("ǰ״̬ɾ").toString();
        }
        SQLFactory sqlFactory = new SQLFactory(this, "ɾ");
        sqlFactory.addParameter("siteid", siteid);
        sqlFactory.addParameter("tagentsid", tagentsid);
        sqlFactory.addParameter("tsupplyanddemandid", tsupplyanddemandid);
        String status = dbConnect.runSqlUpdate(sqlFactory.getSQL());
        if ("true".equals(status)) {
            return getSucReturnObject().toString();
        } else {
            return getErrReturnObject().setErrMsg(status).toString();
        }
    }
}
