package com.cnd3b.restcontroller.enterprise.activity;

import com.alibaba.fastjson.JSONObject;
import com.cnd3b.common.Controller;
import com.cnd3b.common.D3bException;
import com.cnd3b.common.data.Row;
import com.cnd3b.common.data.Rows;
import com.cnd3b.common.data.RowsMap;
import com.cnd3b.common.data.SQLFactory;
import p2.pao.PaoRemote;
import p2.pao.PaoSetRemote;
import p2.util.P2Exception;

import java.util.Date;

public class activity extends Controller {
    public activity(JSONObject content) {
        super(content);
    }

    /**
     * бѯ
     *
     * @return
     */
    public String query_activityList() {
        /**
         *
         */
        String[] sortfield = {"t1.tactivityid desc"};
        String sort = getSort(sortfield, "t1.tactivityid desc");
        /**
         * 
         */
        StringBuffer where = new StringBuffer(" 1=1 ");
        if (content.containsKey("where")) {
            JSONObject whereObject = content.getJSONObject("where");
            if (whereObject.containsKey("condition") && !"".equals(whereObject.getString("condition"))) {
                where.append(" and(");
                where.append("t1.ftitle like'%").append(whereObject.getString("condition")).append("%' ");
                where.append("or t1.fnotes like'%").append(whereObject.getString("condition")).append("%' ");
                where.append(")");
            }
        }
        SQLFactory sqlFactory = new SQLFactory(this, "бѯ", pageSize, pageNumber, sort);
        sqlFactory.addParameter("siteid", siteid);
        sqlFactory.addParameter_SQL("where", where);

        Rows rows = dbConnect.runSqlQuery(sqlFactory.getSQL());
        return getSucReturnObject().setDataByPaging(rows).saveToDataPool().toString();
    }

    /**
     * ޸
     *
     * @return
     */
    public String insertormodify_activity() throws D3bException, P2Exception {
        long tactivityid = content.getLong("tactivityid");
        String ftitle = content.getString("ftitle", "tactivity.ftitle", "");
        String fnotes = content.getString("fnotes", "tactivity.fnotes", "");
        String fshow_url = content.getString("fshow_url", "tactivity.fshow_url", "ҳ");
        // String fstatus = content.getString("fstatus");
        Date fbegdate = content.getDate("fbegdate");//ʼʱ
        Date fenddate = content.getDate("fenddate");//ʱ

        PaoSetRemote tactivitySet = getP2ServerSystemPaoSet("tactivity", "siteid='" + siteid + "' and tactivityid='" + tactivityid + "'");
        PaoRemote tactivity = null;
        if (tactivityid <= 0 || tactivitySet.isEmpty()) {
            tactivity = tactivitySet.addAtEnd();
            tactivity.setValue("siteid", siteid, 11L);//ҵID
            tactivity.setValue("createby", username, 11L);//¼
            tactivity.setValue("createdate", sysdate, 11L);//¼ʱ
        } else {
            tactivity = tactivitySet.getPao(0);
        }
        String fstatus = "";
        if (sysdate.after(fenddate)) {
            fstatus = "ѽ";
        }
        if (sysdate.before(fbegdate)) {
            fstatus = "δʼ";
        }
        tactivity.setValue("fstatus", fstatus, 11L);
        tactivity.setValue("ftitle", ftitle, 11L);
        tactivity.setValue("fnotes", fnotes, 11L);
        tactivity.setValue("fshow_url", fshow_url, 11L);
        tactivity.setValue("fbegdate", fbegdate, 11L);
        tactivity.setValue("fenddate", fenddate, 11L);
        tactivity.setValue("changedate", sysdate, 11L);
        tactivity.setValue("changeby", username, 11L);

        content.put("tactivityid", tactivity.getUniqueIDValue());
        tactivitySet.save();
        return getSucReturnObject().toString();
    }

    /**
     * ̻бѯ
     *
     * @return
     */
    public String query_activityAgentList() {
        long tactivityid = content.getLong("tactivityid");

        /**
         *
         */
        String[] sortfield = {"t1.tactivity_agentmsgid desc"};
        String sort = getSort(sortfield, "t1.tactivity_agentmsgid desc");
        /**
         * 
         */
        StringBuffer where = new StringBuffer(" 1=1 ");
        if (content.containsKey("where")) {
            JSONObject whereObject = content.getJSONObject("where");
            if (whereObject.containsKey("condition") && !"".equals(whereObject.getString("condition"))) {
                where.append(" and(");
                where.append("t2.fagentname like'%").append(whereObject.getString("condition")).append("%' ");
                where.append("or t1.fbrand like'%").append(whereObject.getString("condition")).append("%' ");
                where.append(")");
            }
            if (whereObject.getBooleanValue("iscreatelive")) {
                //Ƿչֱ
                where.append(" and not exists( select * from tlive where siteid='" + siteid + "' " +
                        "and tactivityid='" + tactivityid + "' and tagentsid=t1.tagentsid) ");
            }
        }
        SQLFactory sqlFactory = new SQLFactory(this, "̻бѯ", pageSize, pageNumber, sort);
        sqlFactory.addParameter("siteid", siteid);
        sqlFactory.addParameter("tactivityid", tactivityid);
        sqlFactory.addParameter_SQL("where", where);
       // String sql = sqlFactory.getSQL();
        Rows rows = dbConnect.runSqlQuery(sqlFactory.getSQL());
        RowsMap brandlogoRowsMap = getAttachmentUrl("tagents", rows.toArrayList("tagentsid"), "brandlogo");
        for (Row row : rows) {
            row.put("attinfos", brandlogoRowsMap.get(row.getString("tagentsid")));
        }
        return getSucReturnObject().setDataByPaging(rows).saveToDataPool().toString();
    }

    /**
     * ̻ѯ
     *
     * @return
     */
    public String query_activityAgentMain() {
        long tactivityid = content.getLong("tactivityid");
        long tagentsid = content.getLong("tagentsid");

        SQLFactory sqlFactory = new SQLFactory(this, "̻ѯ");
        sqlFactory.addParameter("siteid", siteid);
        sqlFactory.addParameter("tactivityid", tactivityid);
        sqlFactory.addParameter("tagentsid", tagentsid);
        Rows rows = dbConnect.runSqlQuery(sqlFactory.getSQL());
        RowsMap brandlogoRowsMap = getAttachmentUrl("tagents", rows.toArrayList("tagentsid"), "brandlogo");
        for (Row row : rows) {
            row.put("attinfos", brandlogoRowsMap.get(row.getString("tagentsid")));
        }
        return getSucReturnObject().setData(rows).saveToDataPool().toString();
    }

    /**
     * ̻
     *
     * @return
     */
    public String insertormodify_activityAgent() throws D3bException, P2Exception {
        long tactivityid = content.getLong("tactivityid");
        long tagentsid = content.getLong("tagentsid");

        String fbrand = content.getString("fbrand", "tactivity_agentmsg.fbrand", "չƷ");
        String fcontact = content.getString("fcontact", "tactivity_agentmsg.fcontact", "ϵ");
        String fintroduction = content.getString("fintroduction", "tactivity_agentmsg.fintroduction", "̻");
        String flocation = content.getString("flocation", "tactivity_agentmsg.flocation", "λáչλ");
        String flocationclass = content.getString("flocationclass", "tactivity_agentmsg.flocationclass", "λáչ");
        String fphonenumber = content.getString("fphonenumber", "tactivity_agentmsg.fphonenumber", "ϵֻ");
        String fstatus = content.getString("fstatus", "tactivity_agentmsg.fstatus", "״̬");


        PaoSetRemote tactivity_agentmsgSet = getP2ServerSystemPaoSet("tactivity_agentmsg", "siteid='" + siteid + "' and tactivityid='" + tactivityid + "' and tagentsid='" + tagentsid + "'");
        PaoRemote tactivity_agentmsg = null;
        if (tactivity_agentmsgSet.isEmpty()) {
            tactivity_agentmsg = tactivity_agentmsgSet.addAtEnd();
            tactivity_agentmsg.setValue("tactivityid", tactivityid, 11L);
            tactivity_agentmsg.setValue("tagentsid", tagentsid, 11L);
            tactivity_agentmsg.setValue("siteid", siteid, 11L);//ҵID
            tactivity_agentmsg.setValue("createby", username, 11L);//¼
            tactivity_agentmsg.setValue("createdate", sysdate, 11L);//¼ʱ
        } else {
            tactivity_agentmsg = tactivity_agentmsgSet.getPao(0);
        }
        tactivity_agentmsg.setValue("fstatus", fstatus, 11L);
        tactivity_agentmsg.setValue("fbrand", fbrand, 11L);
        tactivity_agentmsg.setValue("fcontact", fcontact, 11L);
        tactivity_agentmsg.setValue("fintroduction", fintroduction, 11L);
        tactivity_agentmsg.setValue("flocation", flocation, 11L);
        tactivity_agentmsg.setValue("flocationclass", flocationclass, 11L);
        tactivity_agentmsg.setValue("fphonenumber", fphonenumber, 11L);
        tactivity_agentmsg.setValue("changedate", sysdate, 11L);
        tactivity_agentmsg.setValue("changeby", username, 11L);

        content.put("tactivityid", tactivity_agentmsg.getUniqueIDValue());
        tactivity_agentmsgSet.save();

        return query_activityAgentMain();
    }

    /**
     * ɾ̻
     *
     * @return
     */
    public String delete_activityAgent() throws D3bException, P2Exception {
        long tactivityid = content.getLong("tactivityid");
        long tagentsid = content.getLong("tagentsid");

        SQLFactory sqlFactory = new SQLFactory(this, "̻ɾ");
        sqlFactory.addParameter("siteid", siteid);
        sqlFactory.addParameter("tactivityid", tactivityid);
        sqlFactory.addParameter("tagentsid", tagentsid);
        dbConnect.runSqlUpdate(sqlFactory.getSQL());
        return query_activityAgentMain();
    }

    /**
     * ̻Ʒбѯ
     *
     * @return
     */
    public String query_activityAgentMain_prodlist() {
        long tactivityid = content.getLong("tactivityid");
        long tagentsid = content.getLong("tagentsid");
        /**
         *
         */
        String[] sortfield = {"t1.tagents_productid desc"};
        String sort = getSort(sortfield, "t1.tagents_productid desc");

        SQLFactory prodsql = new SQLFactory(this, "̻ѯ_Ʒб", pageSize, pageNumber, sort);
        prodsql.addParameter("siteid", siteid);
        prodsql.addParameter("tactivityid", tactivityid);
        prodsql.addParameter("tagentsid", tagentsid);
        Rows prodRows = dbConnect.runSqlQuery(prodsql.getSQL());
        RowsMap prodattinfosMap = getAttachmentUrl("tagents_product", prodRows.toArrayList("tagents_productid"));

        for (Row prodrow : prodRows) {
            prodrow.put("attinfos", prodattinfosMap.get(prodrow.getString("tagents_productid")));
        }
        return getSucReturnObject().setDataByPaging(prodRows).saveToDataPool().toString();
    }

    /**
     * ̻Ʒ
     *
     * @return
     */
    public String insertormodify_activityAgentProd() throws D3bException, P2Exception {
        long tactivityid = content.getLong("tactivityid");
        long tagentsid = content.getLong("tagentsid");
        long tagents_productid = content.getLong("tagents_productid");

        String fintroduction = content.getString("fintroduction", "tactivity_agentproducts.fintroduction", "Ʒ");

        PaoSetRemote tactivity_agentproductsSet = getP2ServerSystemPaoSet("tactivity_agentproducts", "siteid='" + siteid + "' and tactivityid='" + tactivityid + "' and tagentsid='" + tagentsid + "' and tagents_productid='" + tagents_productid + "'");
        PaoRemote tactivity_agentproducts = null;
        if (tactivity_agentproductsSet.isEmpty()) {
            tactivity_agentproducts = tactivity_agentproductsSet.addAtEnd();
            tactivity_agentproducts.setValue("tactivityid", tactivityid, 11L);
            tactivity_agentproducts.setValue("tagentsid", tagentsid, 11L);
            tactivity_agentproducts.setValue("tagents_productid", tagents_productid, 11L);
            tactivity_agentproducts.setValue("siteid", siteid, 11L);//ҵID
            tactivity_agentproducts.setValue("createby", username, 11L);//¼
            tactivity_agentproducts.setValue("createdate", sysdate, 11L);//¼ʱ
        } else {
            tactivity_agentproducts = tactivity_agentproductsSet.getPao(0);
        }
        tactivity_agentproducts.setValue("fintroduction", fintroduction, 11L);
        tactivity_agentproducts.setValue("changedate", sysdate, 11L);
        tactivity_agentproducts.setValue("changeby", username, 11L);
        tactivity_agentproductsSet.save();
        return getSucReturnObject().toString();
    }

    /**
     * ɾƷ
     *
     * @return
     */
    public String delete_activityAgentProd() {
        long tactivityid = content.getLong("tactivityid");
        long tagentsid = content.getLong("tagentsid");
        long tagents_productid = content.getLong("tagents_productid");

        SQLFactory sqlFactory = new SQLFactory(this, "̻Ʒɾ");
        sqlFactory.addParameter("siteid", siteid);
        sqlFactory.addParameter("tactivityid", tactivityid);
        sqlFactory.addParameter("tagentsid", tagentsid);
        sqlFactory.addParameter("tagents_productid", tagents_productid);
        dbConnect.runSqlUpdate(sqlFactory.getSQL());
        return query_activityAgentMain();
    }

    /**
     * ɾ
     *
     * @return
     */
    public String delete_activity() {
        long tactivityid = content.getLong("tactivityid");
        Rows rows = dbConnect.runSqlQuery("select fstatus from tactivity where siteid='" + siteid + "' and tactivityid=" + tactivityid);
        if (!rows.isEmpty() && !"δʼ".equals(rows.get(0).getString("fstatus"))) {
            return getErrReturnObject().setErrMsg(rows.get(0).getString("fstatus") + "״̬ɾ").toString();
        }
        SQLFactory sqlFactory = new SQLFactory(this, "ɾ");
        sqlFactory.addParameter("siteid", siteid);
        sqlFactory.addParameter("tactivityid", tactivityid);

        String status = dbConnect.runSqlUpdate(sqlFactory.getSQL());
        if ("true".equalsIgnoreCase(status)) {
            return getSucReturnObject().toString();
        } else {
            return getErrReturnObject().setErrMsg(status).toString();
        }
    }

}
