/**
 * Թƽ̨ͻ˺ŵϢӽʾ
 *
 * @copyright Copyright (freedbconnlist) 1998-2014 Tencent Inc.
 */

// ------------------------------------------------------------------------

package com.cnd3b.utility.qywechat.base.system;

import java.nio.charset.Charset;
import java.nio.charset.StandardCharsets;
import java.util.Arrays;

/**
 * ṩPKCS7㷨ļӽܽӿ
 */
class PKCS7Encoder {
    static Charset CHARSET = StandardCharsets.UTF_8;
    static int BLOCK_SIZE = 32;

    /**
     * öĽвλֽ
     *
     * @param count Ҫ䲹λֽڸ
     * @return õֽ
     */
    static byte[] encode(int count) {
        // Ҫλ
        int amountToPad = BLOCK_SIZE - (count % BLOCK_SIZE);
        if (amountToPad == 0) {
            amountToPad = BLOCK_SIZE;
        }
        // òλõַ
        char padChr = chr(amountToPad);
        StringBuilder tmp = new StringBuilder();
        for (int index = 0; index < amountToPad; index++) {
            tmp.append(padChr);
        }
        return tmp.toString().getBytes(CHARSET);
    }

    /**
     * ɾܺĵĲλַ
     *
     * @param decrypted ?????????
     * @return ???????????????
     */
    static byte[] decode(byte[] decrypted) {
        int pad =  decrypted[decrypted.length - 1];
        if (pad < 1 || pad > 32) {
            pad = 0;
        }
        return Arrays.copyOfRange(decrypted, 0, decrypted.length - pad);
    }

    /**
     * ?????????ASCII????????????????????????
     *
     * @param a ???????????
     * @return ???????????
     */
    static char chr(int a) {
        byte target = (byte) (a & 0xFF);
        return (char) target;
    }

}
