package com.cnd3b.utility.qywechat.tools;

import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import com.cnd3b.utility.qywechat.base.GetAccessToken;
import com.cnd3b.utility.qywechat.base.Parameter;

import java.io.IOException;
import java.io.InputStream;
import java.io.OutputStream;
import java.net.HttpURLConnection;
import java.net.MalformedURLException;
import java.net.URL;
import java.nio.charset.StandardCharsets;
public class CreateMenu {
    public static void main(String args[]) {
        JSONObject object = new JSONObject();

        JSONArray array = new JSONArray();

        {
            JSONObject click = new JSONObject();
            click.put("type", "click");
            click.put("name", "Ϣ");
            click.put("key", "01");
            array.add(click);
        }
        {
            JSONObject click = new JSONObject();
            click.put("type", "click");
            click.put("name", "˻Ϣ");
            click.put("key", "02");
            array.add(click);
        }

        object.put("button", array);
        CreateMenu.createMenu(object.toString(), Parameter.appid_DRP);
    }

    /**
     * Menu
     *
     * @param @return
     * @param @throws IOException 趨ļ
     * @return int 
     * @throws
     * @Title: createMenu
     * @Description: Menu
     */
    public static String createMenu(String menu, String appid) {
        // ˴ΪԼҪĽṹ壬滻
        String access_token = GetAccessToken.get();
        String action = "https://qyapi.weixin.qq.com/cgi-bin/menu/create?access_token="
                + access_token + "&agentid=" + appid;
        try {
            URL url = new URL(action);
            HttpURLConnection http = (HttpURLConnection) url.openConnection();
            http.setRequestMethod("POST");
            http.setRequestProperty("Content-Type",
                    "application/x-www-form-urlencoded");
            http.setDoOutput(true);
            http.setDoInput(true);
            System.setProperty("sun.net.client.defaultConnectTimeout", "30000");// ӳʱ30
            System.setProperty("sun.net.client.defaultReadTimeout", "30000"); // ȡʱ30
            http.connect();
            OutputStream os = http.getOutputStream();
            os.write(menu.getBytes(StandardCharsets.UTF_8));// 
            os.flush();
            os.close();

            InputStream is = http.getInputStream();
            int size = is.available();
            byte[] jsonBytes = new byte[size];
            is.read(jsonBytes);
            String message = new String(jsonBytes, StandardCharsets.UTF_8);
            return "Ϣ" + message;
        } catch (MalformedURLException e) {
            e.printStackTrace();
        } catch (IOException e) {
            e.printStackTrace();
        }
        return "createMenu ʧ";
    }

    /**
     * ɾǰMenu
     *
     * @param @return 趨ļ
     * @return String 
     * @throws
     * @Title: deleteMenu
     * @Description: ɾǰMenu
     */
    public static String deleteMenu() {
        String access_token = GetAccessToken.get();
        String action = "https://api.weixin.qq.com/cgi-bin/menu/delete? access_token="
                + access_token;
        try {
            URL url = new URL(action);
            HttpURLConnection http = (HttpURLConnection) url.openConnection();

            http.setRequestMethod("GET");
            http.setRequestProperty("Content-Type",
                    "application/x-www-form-urlencoded");
            http.setDoOutput(true);
            http.setDoInput(true);
            System.setProperty("sun.net.client.defaultConnectTimeout", "30000");// ӳʱ30
            System.setProperty("sun.net.client.defaultReadTimeout", "30000"); // ȡʱ30
            http.connect();
            OutputStream os = http.getOutputStream();
            os.flush();
            os.close();

            InputStream is = http.getInputStream();
            int size = is.available();
            byte[] jsonBytes = new byte[size];
            is.read(jsonBytes);
            String message = new String(jsonBytes, StandardCharsets.UTF_8);
            return "deleteMenuϢ:" + message;
        } catch (MalformedURLException e) {
            e.printStackTrace();
        } catch (IOException e) {
            e.printStackTrace();
        }
        return "deleteMenu ʧ";
    }
}
