package com.cnd3b.utility.qywechat.tools.media_manage;

import com.alibaba.fastjson.JSONObject;
import com.cnd3b.utility.qywechat.base.GetAccessToken;

import java.io.*;
import java.net.HttpURLConnection;
import java.net.URL;
import java.nio.charset.StandardCharsets;
public class UpLoad {
	String result = "";
	/**
	 * ϴʱزļ
	 * 
	 * @param type ýļֱͣͼƬimagevoiceƵvideoͨļ(file)
	 * @param files ļַ
	 */
	public UpLoad(String type, String files) throws IOException { 
		URL url = new URL(
				"https://qyapi.weixin.qq.com/cgi-bin/media/upload?access_token="
						+ GetAccessToken.get() + "&type=" + type);
		File file = new File(files);
		Up(url, file);
	}
	/**
	 * ϴزļ
	 * 
	 * @param appid ӦID
	 * @param type ýļֱͣͼƬimagevoiceƵvideoͨļ(file)
	 * @param files ļַ
	 */
	public UpLoad(String appid,String type,String files) throws IOException {
		URL url = new URL(
				"https://qyapi.weixin.qq.com/cgi-bin/material/add_material?agentid="+appid+"&type="+type+"&access_token="+GetAccessToken.get());
		File file = new File(files);
		Up(url, file);
	}

	public void Up(URL url, File file) throws IOException {
		HttpURLConnection connection = (HttpURLConnection) url.openConnection();
		connection.setRequestMethod("POST");
		connection.setDoOutput(true);
		connection.setDoInput(true);
		connection.setUseCaches(false);
		// ͷϢ
		connection.setRequestProperty("Connection", "Keep-Alive");
		connection.setRequestProperty("Charset", "UTF-8");
		String BOUNDARY = "----------" + System.currentTimeMillis();
		connection.setRequestProperty("Content-Type",
				"multipart/form-data; boundary=" + BOUNDARY);
		// -------------------------------
		// һ֣

		String sb = "--" + // 
				BOUNDARY +
				"\r\n" +
				"Content-Disposition: form-data;name=\"file\";filename=\""
				+ file.getName() + "\"\r\n" +
				"Content-Type:application/octet-stream\r\n\r\n";
		byte[] head = sb.getBytes(StandardCharsets.UTF_8);
		// 
		OutputStream outputStream = connection.getOutputStream();
		// ͷ
		outputStream.write(head);
		// -------------------------------

		// ȡýļȡļ
		BufferedInputStream bis = new BufferedInputStream(new FileInputStream(
				file));
		byte[] buf = new byte[1024];
		int size = 0;
		while ((size = bis.read(buf)) != -1) {
			// ýļд΢ŷдݣ
			outputStream.write(buf, 0, size);
		}

		// β
		byte[] foot = ("\r\n--" + BOUNDARY + "--\r\n").getBytes(StandardCharsets.UTF_8);// ݷָ
		outputStream.write(foot);

		// 
		outputStream.close();
		bis.close();

		// ȡýļϴ΢ŷݣ
		BufferedReader in = new BufferedReader(new InputStreamReader(
				connection.getInputStream()));
		StringBuffer content = new StringBuffer();
		String line = null;
		while ((line = in.readLine()) != null) {
			content.append(line);
		}
		in.close();
		// Դӡ
		result = content.toString();
	}

	public String getresult() {
		return result;
	}
	public String getMedia_id() {
		JSONObject jsonObject = JSONObject.parseObject(result);
		return(String) jsonObject.get("media_id");
	}
}
