package com.cnd3b.restcontroller.customer.usercenter.usermsg;

import com.alibaba.fastjson.JSONObject;
import com.cnd3b.common.Controller;
import com.cnd3b.common.D3bException;
import com.cnd3b.common.data.Row;
import com.cnd3b.common.data.Rows;
import com.cnd3b.common.data.SQLFactory;
import com.cnd3b.common.parameter.parameter;
import p2.pao.PaoRemote;
import p2.pao.PaoSetRemote;
import p2.util.P2Exception;

import java.util.ArrayList;
import java.util.Date;

public class usermsg extends Controller {
    public usermsg(JSONObject content) {
        super(content);
    }

    /**
     * Ϣѯ
     *
     * @return
     */
    public String query_usermsg() {
        SQLFactory sqlFactory = new SQLFactory(this, "ûϢѯ");
        sqlFactory.addParameter("siteid", siteid);
        sqlFactory.addParameter("userid", userid);
        sqlFactory.addParameter("tagentsid", tagentsid);
        Rows rows = dbConnect.runSqlQuery(sqlFactory.getSQL());
        for (Row row : rows) {
            SQLFactory sqlFactory2 = new SQLFactory(this, "û汾Ȩѯ");
            sqlFactory2.addParameter("siteid", siteid);
            sqlFactory2.addParameter("tagentsid", tagentsid);
            Rows rows2 = dbConnect.runSqlQuery(sqlFactory2.getSQL());
            if (rows2.isEmpty()) {
                row.put("fappmodel", "");
                row.put("fauthenddate", "");
            } else {
                row.put("fappmodel", rows2.get(0).getString("fappmodel"));
                row.put("fauthenddate", rows2.get(0).getString("fauthenddate"));
            }
            row.put("attinfos", getAttachmentUrl("tenterprise_users", String.valueOf(userid), "headportrait"));
        }
        return getSucReturnObject().setData(rows).toString();
    }

    /**
     * Ϣ޸
     *
     * @return
     */
    public String update_usermsg() throws D3bException, P2Exception {
        String fname = content.getString("fname", "tenterprise_users.fname", "˺");//
        String fsex = content.getString("fsex");//Ա
        String frole = content.getString("frole", "tenterprise_users.frole", "/ְλ");//ְλ
        Date fbirthdate = content.getDate("fbirthdate");//
        String femail = content.getString("femail", "tenterprise_users.femail", "");//
        String fwechatno = content.getString("fwechatno", "tenterprise_users.fwechatno", "΢");//΢ź
        String faddress = content.getString("faddress", "tenterprise_users.faddress", "ַ");//ַ
        PaoSetRemote tenterprise_usersSet = getP2ServerSystemPaoSet("tenterprise_users", "siteid='" + siteid + "' and tagentsid='" + tagentsid + "' and tenterprise_userid='" + userid + "'");
        if (!tenterprise_usersSet.isEmpty()) {
            PaoRemote pao = tenterprise_usersSet.getPao(0);
            pao.setValue("fname", fname, 11L);
            pao.setValue("fsex", fsex, 11L);
            pao.setValue("fbirthdate", fbirthdate, 11L);
            pao.setValue("femail", femail, 11L);
            pao.setValue("fwechatno", fwechatno, 11L);
            pao.setValue("changeby", username, 11L);
            pao.setValue("changedate", getDateTime(), 11L);
            pao.setValue("faddress", (faddress == null || faddress.equalsIgnoreCase("null")) ? "" : faddress, 11L);
            pao.setValue("frole", frole, 11L);
            tenterprise_usersSet.save();

            //޸˺ȻϢ
            Row row = parameter.userIdList.get(userid);
            row.put("fname", fname);
            parameter.userIdList.put(userid, row);

            if (fisadministrator) {
                ArrayList<String> sqllist = new ArrayList<>();
                sqllist.add("update tagents set faddress='" + faddress + "',fcontact='" + fname + "',fphonenumber='" + fphonenumber + "' where siteid='" + siteid + "' and tagentsid=" + tagentsid + " and ftype=''");
                sqllist.add("update timdialogusers set fname='" + fname + "'where siteid='" + siteid + "' and tenterprise_userid='" + userid + "'");
                dbConnect.runSqlUpdate(sqllist);
            }
        } else {
            throw new D3bException("Ҳ˺Ϣ");
        }

        return query_usermsg();
    }
}
