package com.cnd3b.restcontroller.enterprise.system;

import com.alibaba.fastjson.JSONObject;
import com.cnd3b.common.Controller;
import com.cnd3b.common.D3bException;
import com.cnd3b.common.data.Row;
import com.cnd3b.common.data.Rows;
import com.cnd3b.common.data.RowsMap;
import com.cnd3b.common.data.SQLFactory;
import p2.pao.PaoRemote;
import p2.pao.PaoSetRemote;
import p2.util.P2Exception;

public class supplyanddemand extends Controller {
    public supplyanddemand(JSONObject content) {
        super(content);
    }

    /**
     * бѯ
     *
     * @return
     */
    public String query_typeList() {
        SQLFactory sql = new SQLFactory(this, "ѯ");
        sql.addParameter("siteid", siteid);
        Rows rows = dbConnect.runSqlQuery(sql.getSQL());
        RowsMap map = getAttachmentUrl("ttypedetail", rows.toArrayList("ttypedetailid"));
        for (Row row : rows) {
            row.put("attinfos", map.get(row.getString("ttypedetailid")));
        }
        return getSucReturnObject().setData(rows).saveToDataPool().toString();
    }

    /**
     * ޸
     *
     * @return
     */
    public String insert_modify_type() throws D3bException, P2Exception {
        long ttypedetailid = content.getLongValue("ttypedetailid");//Ϊ0
        String ftype = content.getString("ftype", "ttypedetail.fvalue", "");
        boolean fisused = content.getBoolean("fisused");

        Rows rows = dbConnect.runSqlQuery("select * from ttypedetail where siteid='" + siteid + "' and ftype='' and fvalue='" + ftype + "'");
        if (!rows.isEmpty() && rows.get(0).getLong("ttypedetailid") != ttypedetailid) {
            return getErrReturnObject().setErrMsg("಻ظ").toString();
        }
        PaoSetRemote ttypedetailSet = getP2ServerSystemPaoSet("ttypedetail", "siteid='" + siteid + "' and ttypedetailid='" + ttypedetailid + "'");
        PaoRemote ttypedetail = null;
        if (ttypedetailSet.isEmpty()) {
            ttypedetail = ttypedetailSet.addAtEnd();
            ttypedetail.setValue("siteid", siteid, 11L);//ҵID
            ttypedetail.setValue("ftype", "", 11L);
        } else {
            ttypedetail = ttypedetailSet.getPao(0);
        }
        ttypedetail.setValue("fvalue", ftype, 11L);
        ttypedetail.setValue("fisused", fisused, 11L);
        ttypedetailSet.save();
        return getSucReturnObject().toString();
    }

    /**
     * ɾ
     *
     * @return
     */
    public String delete_type() {
        SQLFactory sqlFactory = new SQLFactory(this, "ɾ");
        sqlFactory.addParameter("siteid", siteid);
        sqlFactory.addParameter("ttypedetailid", content.getString("ttypedetailid"));
        String result = dbConnect.runSqlUpdate(sqlFactory.getSQL());
        if ("true".equals(result)) {
            return getSucReturnObject().toString();
        } else {
            return getErrReturnObject().setErrMsg(result).toString();
        }
    }

    /**
     * ѡѯ
     *
     * @return
     */
    public String query_typeselectList() {
        Rows rows = dbConnect.runSqlQuery("select ttypedetailid,fvalue as ftype from ttypedetail where ftype = '' and siteid ='" + siteid + "' and fisused=1 order by sequence");
        RowsMap map = getAttachmentUrl("ttypedetail", rows.toArrayList("ttypedetailid"));
        for (Row row : rows) {
            row.put("attinfos", map.get(row.getString("ttypedetailid")));
        }
        return getSucReturnObject().setData(rows).toString();
    }
}