SELECT t1.tsupplyanddemandid,
       t1.fissupply,
       t1.ftype,
       t1.ftitle,
       t1.fcontent,
       t1.fstatus,
       t1.createby,
       t1.checkby,
       t1.checkdate,
       t1.fenddate,
       t2.fagentname,
       t1.tagentsid,
       t1.tenterprise_userid,
       t1.freadtimes,
       (select count(0)
        from timdialog
        where siteid = t1.siteid
          and ownertable = 'tsupplyanddemand'
          and ownerid = t1.tsupplyanddemandid) as fcommunicationtimes

from tsupplyanddemand as t1
         inner join tagents t2 on t1.siteid=t2.siteid and t1.tagentsid=t2.tagentsid
WHERE t1.siteid = $siteid$
  and t1.fstatus not in ('½')
  and (t1.fcontent LIKE $keyStr$ OR t1.createby LIKE $keyStr$ OR t1.ftitle LIKE $keyStr$)