package com.cnd3b.restcontroller.publicmethod.live;

import com.alibaba.fastjson.JSONObject;
import com.cnd3b.common.Controller;
import com.cnd3b.common.data.Row;
import com.cnd3b.common.data.Rows;
import com.cnd3b.common.data.RowsMap;
import com.cnd3b.common.data.SQLFactory;


public class live extends Controller {
    public live(JSONObject content) {
        super(content);
    }

    /**
     * ȡǰֱ̻
     *
     * @return
     */
    public String getLiveChannelData() {
        String tactivityid = content.getString("tactivityid");
        String saleprodclass = content.getString("saleprodclass");
        if(saleprodclass==null){
            saleprodclass = "";
        }
        JSONObject resultObject = new JSONObject();
        //չ
        SQLFactory agentcountSql = new SQLFactory(this, "ֱѯ");
        agentcountSql.addParameter("tactivityid", tactivityid);
        agentcountSql.addParameter("siteid", siteid);
        Rows agentCountRows = agentcountSql.runSqlQuery();
        resultObject.put("fagentcount", agentCountRows.isEmpty() ? 0 : agentCountRows.get(0).getInteger("fcount"));

        //
        SQLFactory custcountSql = new SQLFactory(this, "ֱѯ");
        custcountSql.addParameter("tactivityid", tactivityid);
        custcountSql.addParameter("siteid", siteid);
        Rows totalcustCountrows = custcountSql.runSqlQuery();
        resultObject.put("ftotalcustcount", totalcustCountrows.isEmpty() ? 0 : totalcustCountrows.get(0).getInteger("fcount"));

        SQLFactory livecustcount = new SQLFactory(this, "ǰϹѯ");
        livecustcount.addParameter("tactivityid", tactivityid);
        livecustcount.addParameter("siteid", siteid);
        livecustcount.addParameter("saleprodclass","%"+saleprodclass+"%");
        Rows liverows = dbConnect.runSqlQuery(livecustcount.getSQL());

        String sql = livecustcount.getSQL();

        SQLFactory brandcustcount = new SQLFactory(this, "̻");
        brandcustcount.addParameter("tactivityid", tactivityid);
        brandcustcount.addParameter("siteid", siteid);
        Rows brandcustcountrows = dbConnect.runSqlQuery(brandcustcount.getSQL());
        int flivecount = liverows.size();
        //ֱ
        resultObject.put("flivecount", flivecount);
        //ǰ߹
        resultObject.put("fcustcount", liverows.isEmpty() ? 0 : liverows.sum("fcustcount"));
        for(Row row:liverows){
            //ۿΣ
            String channelid = row.getString("channelid");
            //ۿˣ
            long viewers = getCount("ֱۿ", "num", channelid);
            row.put("viewers", viewers);
        }
        //ֱб
        int pageSize = content.getIntValue("pageSize");
        int pageNumber = content.getIntValue("pageNumber");
        if (pageSize == 0 || pageNumber == 0) {
            resultObject.put("tlivelist", liverows);
        } else {
            Rows newliverows = new Rows();
            double pageTotal = Math.ceil((double) flivecount / (double) pageSize);//ҳ
            int startindex = (pageNumber - 1) * pageSize;
            int endindex = (pageNumber) * pageSize - 1;
//            if (pageNumber >= pageTotal) {
//                startindex = flivecount - pageSize;
//                endindex = flivecount - 1;
//            }
            for (int i = 0; i < flivecount; i++) {
                if (startindex <= i && i <= endindex) {
                    newliverows.add(liverows.get(i));
                }
            }
            resultObject.put("tlivelist", newliverows);
            resultObject.put("pageSize", pageSize);
            resultObject.put("pageNumber", pageNumber);
            resultObject.put("total", flivecount);
            resultObject.put("pageTotal", pageTotal);
        }
        //̻
        resultObject.put("brandcustcount", brandcustcountrows);
        //չ̻
        Rows fagentcountrows = dbConnect.runSqlQuery("select tagentsid from tactivity_agentmsg where siteid='" + siteid + "' and tactivityid='" + tactivityid + "' ");
        resultObject.put("fagentcount", fagentcountrows.size());
        return getSucReturnObject().setData(resultObject).toString();
    }

    /**
     * ֱͨ״̬ȡŻֱб
     *
     * @return
     */
    public String getHomeLive() {
        //ֱ״̬ unStartδʼ liveֱ endѽ waitingȴ playbackط
        String livestatus = content.getString("livestatus");
        SQLFactory sqlFactory = new SQLFactory(this, "Żֱб", pageSize, pageNumber, "t1.createdate");
        sqlFactory.addParameter("siteid", siteid);
        sqlFactory.addParameter("livestatus", "%" + livestatus + "%");
        System.err.println(sqlFactory.getSQL());
        Rows agentRows = dbConnect.runSqlQuery(sqlFactory.getSQL());
        for (Row row : agentRows) {
            //ۿΣ
            String channelid = row.getString("channelid");
            //ۿˣ
            long viewers = getCount("ֱۿ", "num", channelid);
            row.put("viewers", viewers);
        }
        return getSucReturnObject().setDataByPaging(agentRows).preloading(1).toString();
    }

    public long getCount(String SQLMODELNAME, String fieldname, String channelid) {
        SQLFactory sqlFactory = new SQLFactory(this, SQLMODELNAME);
        sqlFactory.addParameter("channelid", channelid);
        Rows rows = sqlFactory.runSqlQuery();
        return rows.isEmpty() ? 0 : rows.get(0).getLong(fieldname);
    }


    /**
     * չ
     *
     * @return
     */
    public String agentList() {
        String tactivityid = content.getString("tactivityid");
        SQLFactory agentlistSql = new SQLFactory(this, "չ");
        agentlistSql.addParameter("tactivityid", tactivityid);
        agentlistSql.addParameter("siteid", siteid);
        Rows rows = agentlistSql.runSqlQuery();
        RowsMap map = getAttachmentUrl("tagents", rows.toArrayList("tagentsid"));
        for (Row row : rows) {
            row.put("attinfos", map.get(row.getString("tagentsid")));
        }
        return getSucReturnObject().setData(rows).saveToDataPool(10).toString();
    }

    /**
     * չƷ
     *
     * @return
     */
    public String prodList() {
        String tactivityid = content.getString("tactivityid");
        SQLFactory prodlistSql = new SQLFactory(this, "չƷ");
        prodlistSql.addParameter("tactivityid", tactivityid);
        prodlistSql.addParameter("siteid", siteid);
        Rows rows = prodlistSql.runSqlQuery();
        RowsMap map = getAttachmentUrl("tagents_product", rows.toArrayList("tagents_productid"));
        for (Row row : rows) {
            row.put("attinfos", map.get(row.getString("tagents_productid")));
        }
        return getSucReturnObject().setData(rows).saveToDataPool(10).toString();
    }

    /**
     * Ϲƣգ
     *
     * @return
     */
    public String getLiveData() {
        String tactivityid = content.getString("tactivityid");
        SQLFactory sql1 = new SQLFactory(this, "Ϲ");
        sql1.addParameter("tactivityid", tactivityid);
        sql1.addParameter("siteid", siteid);
        Rows rows1 = sql1.runSqlQuery();

        SQLFactory sql2 = new SQLFactory(this, "ۿֱռ");
        sql2.addParameter("tactivityid", tactivityid);
        sql2.addParameter("siteid", siteid);
        Rows rows2 = sql2.runSqlQuery();

        SQLFactory sql3 = new SQLFactory(this, "ۿռ");
        sql3.addParameter("tactivityid", tactivityid);
        sql3.addParameter("siteid", siteid);
        Rows rows3 = sql3.runSqlQuery();

        SQLFactory sql4 = new SQLFactory(this, "Ʒռ");
        sql4.addParameter("tactivityid", tactivityid);
        sql4.addParameter("siteid", siteid);
        Rows rows4 = sql4.runSqlQuery();

        JSONObject object = new JSONObject();
        object.put("custcount", rows1);
        object.put("citycount", rows2);
        object.put("channelcount", rows3);
        object.put("saleprodclasscount", rows4);
        return getSucReturnObject().setData(object).saveToDataPool(1).toString();
    }

    public String getPolyvSoftUrl() {
        JSONObject object = new JSONObject();
        object.put("MAC", "http://soft.polyv.net/custom/macCloud/04de51d4c1/4.5.4/Live-Setup.dmg");
        object.put("WIN", "http://live.polyv.net/clients/winClient/04de51d4c1/Live-Setup.exe");
        return getSucReturnObject().setData(object).toString();
    }
}
