package com.cnd3b.utility;

import java.math.BigDecimal;

public class Math {

	/**
	 * ӷ
	 * 
	 * @param arg0
	 * @param arg1
	 * @return
	 */
	public static double add(double arg0, double arg1) {
		BigDecimal b1 = new BigDecimal(Double.toString(arg0));
		BigDecimal b2 = new BigDecimal(Double.toString(arg1));
		return b1.add(b2).doubleValue();
	}

	/**
	 * 
	 * 
	 * @param arg0 
	 * @param arg1 
	 * @return
	 */
	public static double sub(double arg0, double arg1) {
		BigDecimal b1 = new BigDecimal(Double.toString(arg0));
		BigDecimal b2 = new BigDecimal(Double.toString(arg1));
		return b1.subtract(b2).doubleValue();
	}

	/**
	 * ˷
	 * 
	 * @param arg0
	 * @param arg1
	 * @return
	 */
	public static double mul(double arg0, double arg1) {
		BigDecimal b1 = new BigDecimal(Double.toString(arg0));
		BigDecimal b2 = new BigDecimal(Double.toString(arg1));
		return b1.multiply(b2).doubleValue();
	}

	/**
	 * ˷
	 * 
	 * @param arg0
	 * @param arg1
	 * @return
	 */
	public static double mul(double arg0, double arg1, int scale) {
		BigDecimal b1 = new BigDecimal(Double.toString(arg0));
		BigDecimal b2 = new BigDecimal(Double.toString(arg1));

		return round(b1.multiply(b2).doubleValue(), scale);
	}

	/**
	 * Ĭϱ6λ
	 * @param arg0
	 * @param arg1
	 * @return
	 */
	public static double div(double arg0, double arg1) {
		return div(arg0, arg1, 6);
	}

	/**
	 * 
	 * 
	 * @param arg0 
	 * @param arg1 
	 * @param scale   ҪȷСԺλ
	 * @return
	 */
	public static double div(double arg0, double arg1, int scale) {
		if (scale < 0) {
			throw new IllegalArgumentException("ȲС0");
		}
		BigDecimal b1 = new BigDecimal(Double.toString(arg0));
		BigDecimal b2 = new BigDecimal(Double.toString(arg1));
		return b1.divide(b2, scale, BigDecimal.ROUND_HALF_UP).doubleValue();
	}

	/**
	 * 봦
	 * 
	 * @param arg0  Ҫ
	 * @param scale Сλ
	 * @return Ľ
	 */
	public static double round(double arg0, int scale) {
		if (scale < 0) {
			throw new IllegalArgumentException("λС0");
		}
		BigDecimal b = new BigDecimal(Double.toString(arg0));
		BigDecimal one = new BigDecimal("1");
		return b.divide(one, scale, BigDecimal.ROUND_HALF_UP).doubleValue();
	}

	/**
	 * ȡ
	 * @return
	 */
	public static double random() {
		return java.lang.Math.random();
	}

}
