package com.cnd3b.utility.qywechat.base;

public abstract class AppRemote {
	public CreateMsg createMsg;
	public AppRemote() {
		createMsg = new CreateMsg();
	}
	/**
	 * Ϣ
	 * 
	 * @param Content
	 *            Ϣ
	 * @param FromUserName
	 * @param ToUserName
	 * @return صxml
	 */
	public abstract String switchTextMsg(String Content, String FromUserName,
			String ToUserName);

	/**
	 * ͼƬϢ
	 * 
	 * @param PicUrl
	 *            ͼƬĵַ
	 * @param MediaId
	 * @param FromUserName
	 * @param ToUserName
	 * @return صxml
	 */
	public abstract String switchImageMsg(String PicUrl, String MediaId,
			String FromUserName, String ToUserName);

	/**
	 * ƵϢ
	 * 
	 * @param MediaId
	 * @param Format
	 *            ʽ
	 * @param FromUserName
	 * @param ToUserName
	 * @return
	 */
	public abstract String switchVoiceMsg(String MediaId, String Format,
			String FromUserName, String ToUserName);

	/**
	 * ƵϢ
	 * 
	 * @param MediaId
	 * @param ThumbMediaId
	 *            ƵϢͼýidԵûȡýļӿȡ
	 * @param FromUserName
	 * @param ToUserName
	 * @return
	 */
	public abstract String switchVideoMsg(String MediaId, String ThumbMediaId,
			String FromUserName, String ToUserName);

	/**
	 * СƵϢ
	 * 
	 * @param MediaId
	 * @param ThumbMediaId
	 *            ƵϢͼýidԵûȡýļӿȡ
	 * @param FromUserName
	 * @param ToUserName
	 * @return
	 */
	public abstract String switchShortvideoMsg(String MediaId,
			String ThumbMediaId, String FromUserName, String ToUserName);

	/**
	 * λϢ
	 * 
	 * @param Location_X
	 *            γ
	 * @param Location_Y
	 *            
	 * @param Scale
	 *            ͼŴС
	 * @param Label
	 *            λϢ
	 * @param FromUserName
	 * @param ToUserName
	 * @return
	 */
	public abstract String switchLocationMsg(String Location_X,
			String Location_Y, String Scale, String Label, String FromUserName,
			String ToUserName);

	/**
	 * Աעȡ¼
	 * 
	 * @param AgentID
	 * @param FromUserName
	 * @param ToUserName
	 * @return
	 */
	public abstract String switchSubscribeEventMsg(String AgentID,
			String FromUserName, String ToUserName);

	/**
	 * ϱλ¼Զϱ
	 * 
	 * @param AgentID
	 * @param Latitude γ
	 * @param Longitude 
	 * @param Precision 
	 * @param FromUserName
	 * @param ToUserName
	 * @return
	 */
	public abstract String switchLocationEventMsg(String AgentID,
			String Latitude, String Longitude, String Precision,
			String FromUserName, String ToUserName);

	/**
	 * ˵ť¼
	 * 
	 * @param EventKey
	 *            ¼KEYֵԶ˵ӿKEYֵӦ
	 * @param FromUserName
	 * @param ToUserName
	 * @return
	 */
	public abstract String switchClickEventMsg(String EventKey,
			String FromUserName, String ToUserName);

	/**
	 * ˵תӵ¼
	 * @param EventKey ¼KEYֵõתURL
	 * @param FromUserName
	 * @param ToUserName
	 * @return
	 */
	public abstract String switchViewEventMsg(String EventKey,
			String FromUserName, String ToUserName);

	/**
	 * ԱӦõ¼
	 * @param EventKey ¼KEYֵ¼ֵΪ
	 * @param FromUserName
	 * @param ToUserName
	 * @return
	 */
	public abstract String switchEnter_agentEventMsg(String EventKey,
			String FromUserName, String ToUserName);

	/**
	 * ɨ¼¼
	 * @param EventKey ¼KEYֵɿڴ˵ʱ趨
	 * @param ScanType ɨͣһqrcode
	 * @param ScanResult ɨάӦַϢ
	 * @param FromUserName
	 * @param ToUserName
	 * @return
	 */
	public abstract String switchScancode_pushEventMsg(String EventKey,
			String ScanType, String ScanResult, String FromUserName,
			String ToUserName);

	/**
	 * ɨ¼ҵϢСʾ¼
	 * @param EventKey ¼KEYֵɿڴ˵ʱ趨
	 * @param ScanType ɨͣһqrcode
	 * @param ScanResult ɨάӦַϢ
	 * @param FromUserName
	 * @param ToUserName
	 * @return
	 */
	public abstract String switchScancode_waitmsgEventMsg(String EventKey,
			String ScanType, String ScanResult, String FromUserName,
			String ToUserName);

}
