package p2.application.tenterprise;

import baseclass.PaoCust;
import p2.pao.PaoRemote;
import p2.pao.PaoSet;
import p2.pao.PaoSetRemote;
import p2.util.P2AppException;
import p2.util.P2Exception;

import java.util.Calendar;

public class tenterprise extends PaoCust {
    public tenterprise(PaoSet arg0) {
        super(arg0);
    }

    @Override
    protected void save() throws P2Exception {
        super.save();
    }


    public void createdefaultpayinfovalidate() throws P2Exception {
        PaoSetRemote tagentsSet = getPaoSet("tagents");
        createdefaultpayinfovalidate(tagentsSet);
    }

    public void createdefaultpayinfovalidate(PaoSetRemote tagentsSet) throws P2Exception {
        PaoSetRemote tappmodelauthSet = getPaoSet("tappmodelauth");
        tappmodelauthSet.setWhere("fisdefault=1");
        tappmodelauthSet.reset();
        if (tappmodelauthSet.isEmpty()) {
            throw new P2AppException("", "ԸҵӦð汾ȨҪһĬϰ汾Ȩ");
        }

        PaoRemote tappmodelauth = tappmodelauthSet.getPao(0);
        double fagentamount = tappmodelauth.getDouble("fagentamount");
        if (fagentamount <= 0) {
            throw new P2AppException("", "Ĭϰ汾Ȩʵ֧Сڵ0ɸ¼");
        }
        for (PaoRemote tagentpao : (Iterable<PaoRemote>) tagentsSet.getSelection()) {
            PaoSetRemote tpayinfoSet = tagentpao.getPaoSet("tpayinfo", "tpayinfo", "siteid='" + getString("siteid") + "' and tagentsid='" + getUniqueIDValue() + "' and convert(varchar(10),fbegdate,120)<=convert(varchar(10),getdate(),120) and convert(varchar(10),fenddate,120)>=convert(varchar(10),getdate(),120)");
            if (!tpayinfoSet.isEmpty()) {
                throw new P2AppException("", "ǰʱѴһЧĸ¼ظ");
            }
            PaoSetRemote tenterprise_usersSet = tagentpao.getPaoSet("tenterprise_users");
            tenterprise_usersSet.setWhere("fisadministrator=1");
            tenterprise_usersSet.reset();
            if (tenterprise_usersSet.isEmpty()) {
                throw new P2AppException("", "" + tagentpao.getString("fagentname") + "ڹԱ˺,");
            }
        }
    }

    public void createdefaultpayinfo() throws P2Exception {
        PaoSetRemote tagentsSet = getPaoSet("tagents");
        createdefaultpayinfo(tagentsSet);
    }

    public void createdefaultpayinfo(PaoSetRemote tagentsSet) throws P2Exception {
        PaoSetRemote tappmodelauthSet = getPaoSet("tappmodelauth");
        tappmodelauthSet.setWhere("fisdefault=1");
        tappmodelauthSet.reset();
        if (!tappmodelauthSet.isEmpty()) {
            PaoRemote tappmodelauth = tappmodelauthSet.getPao(0);
            String fappmodel = tappmodelauth.getString("fappmodel");
            double fagentamount = tappmodelauth.getDouble("fagentamount");
            for (PaoRemote tagentpao : (Iterable<PaoRemote>) tagentsSet.getSelection()) {
                PaoSetRemote tenterprise_usersSet = tagentpao.getPaoSet("tenterprise_users");
                tenterprise_usersSet.setWhere("fisadministrator=1");
                tenterprise_usersSet.reset();
                if (!tenterprise_usersSet.isEmpty()) {
                    PaoSetRemote tpayinfoSet = tagentpao.getPaoSet("$tpayinfo", "tpayinfo");
                    PaoRemote tpayinfo = tpayinfoSet.addAtEnd();
                    tpayinfo.setValue("siteid", getString("siteid"), 11L);
                    tpayinfo.setValue("famount", fagentamount, 11L);
                    tpayinfo.setValue("fbegdate", getDate(), 11L);
                    Calendar calendar = Calendar.getInstance();
                    calendar.add(Calendar.YEAR, 1);
                    tpayinfo.setValue("fenddate", calendar.getTime(), 11L);
                    tpayinfo.setValue("ftype", "", 11L);
                    tpayinfo.setValue("tagentsid", tagentpao.getUniqueIDValue(), 11L);
                    tpayinfo.setValue("tenterprise_userid", tenterprise_usersSet.getPao(0).getUniqueIDValue(), 11L);
                    tpayinfo.setValue("fappmodel", fappmodel, 11L);
                    tpayinfo.setValue("fsourceobject", "TAGENTS", 11L);
                    tpayinfo.setValue("fsourceid", tagentpao.getUniqueIDValue(), 11L);
                }
            }
        }
    }
}
